<?php
/*
 * mc_exercise.php - Vips plugin for Stud.IP
 * Copyright (c) 2003-2005  Erik Schmitt, Philipp Hgelmeyer
 * Copyright (c) 2005-2006  Christa Deiwiks
 * Copyright (c) 2006-2007  Elmar Ludwig, Martin Schrder
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 */

require_once 'exercises/exercise.php';

/**
 * XXX detailed description
 *
 * @author    XXX
 * @copyright XXX
 * @abstract
 */
class mc_exercise extends Exercise {
    
    var $g_numberOfAnswers;
    var $g_ExerciseName = "Multiple Choice";
    var $g_ExerciseDescription = "DescriptionExerciseMC";
    var $g_maxPoints;
    
    function  mc_exercise() {
//              $this->g_numberOfAnswers                = 5;
//              $this->g_Action                                 = getExternalParam('action');
//              $this->g_OpenObject                     = 'openobject_'. strtolower($this->Action);
//              $this->g_maxPoints = $this->g_numberOfAnswers;
    }
    
    /**************************************************************************/
    /*
    /* Evaluates the solution
    /*
    /**************************************************************************/
    
    /**
     *    Evaluates a solution.
     *
     *    @abstract
     *    @access public
     *    @returns int (from 0 to 100 ) as an % value
     */
    
    function evaluate ($exercise,$solution) {
        $dom_xml = $this->getDomXML($exercise);
        $answers = $dom_xml->get_elements_by_tagname("Answer");
        $mc_auswertung = $this->getEvalMode();
        $punkte = 0;
        
        $answer_array = array();
        $correct_array = array();
        
        foreach ($answers as $node) {
            $answer_array[]         = html_ready(utf8_decode($node->get_content()));
            $correct_array[]        = (int) $node->get_attribute("Correct");
        }
        
        $student_array = $this->getTagsFromXML($solution, "answer");
        
        for ($i = 0; $i < count($correct_array); $i++) {
            if ($student_array[$i] == $correct_array[$i]) 
                ++$punkte;
            else if ($mc_auswertung == 1 || $mc_auswertung == 2)
                --$punkte;      // abzug bei falscher antwort
        }
        
        if ($punkte < 0 && $mc_auswertung != 2)
            $punkte = 0;
        
        $m_prozent = $punkte / count($correct_array) * 100;
        $m_save = 1;
        
        $m_return[1] = $m_prozent;
        $m_return[2] = $m_save;
        $m_return[5] = $punkte;
        return $m_return;
    }
    
    
    
    /**
     * Generates an XML-String containing the solution of the student.
     *
     * Gets ist values to be stored in the XML-String from the
     * Get/Post environment.
     *
     * @param int $exercise_id the id of the exercise the solution related to.
     * @param int $p_number_of_answers the number of answers possible (??? not a class variable, ES)
     * @return XML the XML-String containing the solutions of the student.
     *
     * @todo names of the exml entities are not well choosen. A change will have
     * impact on other parts of the code, of course.
     */
    
    function genSolution($p_exercise_id, $p_number_of_answers) {
        
        $i              = 0;
        $msg    = "<solution id=\"".$p_exercise_id."\">";
        
        while ($i < $p_number_of_answers)
        {
            // the choosen answers are in the get or post environment: 1. Otherwise:0.
            if (getExternalParam("answer_$i")) {
                $msg .= "<answer id=\"".$i."\">";
                $msg .= "<body>1</body>";
                $msg .= "</answer>";
            }
            else {
                $msg .= "<answer id=\"".$i."\">";
                $msg .= "<body>0</body>";
                $msg .= "</answer>";
            } // end if
            $i++;
        } // end while
        
        $msg.= "</solution>";
        return ($msg);
    }
    
    
    
    /**
     * Generate the description af an exercise in an XML-String.
     *
     * Gets ist values to be stored in the XML-String from the
     * Get/Post environment.
     *
     * @return XML the SML-String describing the exercise in terms of its
     * name, questions, worng and correct solutions etc.
     */
    
    function getExerciseConstruct() {
        
        /*************************************************************************/
        /* Get data
        /*************************************************************************/
        
        $m_exercise_language = "de";
        
        $m_exercise_type     = getExternalParam("exercise_type");
        $m_exercise_question = getExternalParam("exercise_question");
        $m_exercise_name     = getExternalParam("exercise_name");
        $m_exerciseHint      = getExternalParam("exercise_hint");
        $m_exercise_comment  = getExternalParam("exercise_comment");
        
        $m_exercise_pic_url  = getExternalParam("exercise_pic_url");  //??
        $m_provides          = getExternalParam("provides");  //??
        $m_depends           = getExternalParam("depends"); //??
        $m_optional_depends  = getExternalParam("optional_depends"); //??
        $m_number_of_answers = getExternalParam("number_of_answers");
        $m_mc_auswertung     = getExternalParam("mc_auswertung");
        
        $this->g_maxPoints = $m_number_of_answers;
        
        #$m_correct_answers   = getExternalParam("correct_answers") == "show"
        #                                                       ? "yes"
        #                                                       : "no";
        
        $i = 0;
        do {
            $correct_array[$i] = getExternalParam("correct_".$i);
            $answer_array[$i]  = getExternalParam("answer_".$i);
            $i++;
        } while ($i < $m_number_of_answers);
        
        /*************************************************************************/
        /* Construct XML
        /*************************************************************************/
        
        $xmlop  = "<TestItem ID=\"" . $m_exercise_type . "\" Type=\"MultipleChoice\" Language=\"" . $m_exercise_language . "\">";
        $xmlop .= "<Name>".htmlspecialchars($m_exercise_name)."</Name>";
        $xmlop .= "<Hint>".htmlspecialchars($m_exerciseHint)."</Hint>";
        $xmlop .= "<CommentField Visible=\"".$m_exercise_comment."\"></CommentField>";
        // $xmlop .= "<CorrectAnswers Visible=\"".$m_correct_answers."\"></CorrectAnswers>";
        $xmlop .= "<PictureURL>".htmlspecialchars($m_exercise_pic_url)."</PictureURL>";
        $xmlop .= "<Provides>".htmlspecialchars($m_provides)."</Provides>";
        $xmlop .= "<Depends>".htmlspecialchars($m_depends)."</Depends>";
        $xmlop .= "<OptionalDepends>".htmlspecialchars($m_optional_depends)."</OptionalDepends>";
        $xmlop .= "<Question>";
        $xmlop .= "<Paragraph>".htmlspecialchars($m_exercise_question)."</Paragraph>";
        $xmlop .= "</Question>";
        $xmlop .= "<EvalMode>".htmlspecialchars($m_mc_auswertung)."</EvalMode>";
        
        for ($i = 0; $i < count($answer_array); $i++) {
            if ($answer_array[$i])  // store only meaningful answers
                $xmlop .= '<Answer Correct="'.$correct_array[$i].'">'.htmlspecialchars($answer_array[$i]).'</Answer>';
        }
        
        $xmlop .= "</TestItem>";
        
        /*************************************************************************/
        /* Return XML
        /*************************************************************************/
        
        return ($xmlop);
    }

    /**
     * Export this exercise to plain text format.
     */
    function exportText ($exercise_xml)
    {
        $result = parent::exportText($exercise_xml, 'MC-Frage');

        $dom_xml = $this->getDomXML($exercise_xml);
        $answers = $dom_xml->get_elements_by_tagname('Answer');

        foreach ($answers as $node)
        {
            $answer_array[] = utf8_decode($node->get_content());
            $correct_array[] = $node->get_attribute('Correct');
        }

        for ($i = 0; $i < count($answer_array); ++$i)
        {
            if ($correct_array[$i] == '1')
                $result .= '+';
            else if ($correct_array[$i] == '0.5')
                $result .= '~';

            $result .= 'Antwort: '.$answer_array[$i]."\n";
        }

        return $result;
    }
}
?>
