<?php
/*
 * pl_exercise.php - Vips plugin for Stud.IP
 * Copyright (c) 2003-2005  Erik Schmitt, Philipp Hgelmeyer
 * Copyright (c) 2005-2006  Christa Deiwiks
 * Copyright (c) 2006-2007  Elmar Ludwig, Martin Schrder
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 */

require_once 'exercises/exercise.php';

/**
 * XXX detailed description
 *
 * @author    Philipp Hgelmeyer
 * @copyright XXX
 * @abstract
 */
class pl_exercise extends Exercise {
    
//      var $g_numberOfAnswers = 1;
//
//    var       $g_ExerciseName         = "Prolog";
//      var     $g_ExerciseDescription  = "DescriptionExercisePL";
//      var     $g_reset        = FALSE;
    
    function pl_exercise() {
//              #$this->g_ExerciseName          = "Prolog";
//              #$this->g_ExerciseDescription   = "DescriptionExercisePL";
//              $this->g_Action                                 = getExternalParam('action');
//              $this->g_OpenObject                     = 'openobject_' . strtolower($this->Action);
    }
    
    /**************************************************************************/
    /*
    /* Evaluates the solution
    /*
    /**************************************************************************/
    
    /**
     *    Evaluates a solution.
     *
     *    @abstract
     *    @access public
     *    @returns int (from 0 to 100 ) as an % value
     */
    
    function evaluate($exercise, $solution, $p_user_id, $p_gesamtpunktzahl, $solutionFromTextarea = FALSE) {  //exception for pl exercises

        $username = get_solver_name($p_user_id);

        $punkte = 0;
        
        $dom_xml = $this->getDomXML($exercise);
        $answers = $dom_xml->get_elements_by_tagname("Answer");
        $node =  $answers[0];
        $musterloesung  = stripslashes(utf8_decode($node->get_content()));
        
        $answer_default         = $this->getTagsFromXML($exercise, "AnswerDefault");
        $answerDefault          = stripslashes($answer_default[0]);
        
        $testcase = '';
        if ($solutionFromTextarea) {
            $testcase = stripslashes(getExternalParam("answer_0"));
        }
        else {
            $student_array = $this->getTagsFromXML($solution, "answer");
            $testcase =  $student_array[0];
        }
        
        $course = $g_outlet->courseID; 
        
        $shell_output = "";
        $fp = fsockopen("mvc.ikw.uni-osnabrueck.de", 2213); //, $errno, $errstr, 30);
        if (!$fp) {
            echo "ERROR fsockopen: PROLOG compiler couldn't be reached'."; //"$errstr ($errno)<br />\n";
        } 
        else 
        {
            $queryXML = "<prolog>\n<init>\n$answerDefault\n</init>\n<user>\n$username\n</user>\n<course>\n$course\n</course>\n<magic>\n!ViPS!\n</magic>\n<number>\n1\n</number>\n<type>\neval\n</type>\n<exercise>\n".$testcase."\n</exercise>\n<testcase>\n".$musterloesung."\n</testcase>\n</prolog>\n";
            //echo "<br>Query<pre>: $queryXML </pre>";
            fputs($fp, $queryXML);
            while (!feof($fp))      {       $shell_output .= fgets($fp);    }
            fclose($fp);
        }
//              echo "<br>shell_output<pre>: $shell_output </pre>";
        
        list($score1,$rest) = split("<Score>",$shell_output);
        list($score, $rest) = split("</Score>",$rest);
        
        list($output1,$rest) = split("<Output>",$shell_output);
        list($output,$rest) = split("</Output>",$rest);
        
        list($validity1,$rest) = split("<Validity>",$shell_output);
        list($validity,$rest) = split("</Validity>",$rest);

        if ($validity == 1) {
            $m_save = 1;
        }

        $m_return = array();

        $prozent = $score * 100;
        $punkte = $score * $p_gesamtpunktzahl;  // 2,3824 von 5
        $punkte = floor($punkte * 10) / 10;     // 23,824 -> 2,3 

        $m_return[1] = $prozent;  //prozent
        $m_return[2] = $m_save;
        $m_return[5] = $punkte;  //punktzahl
        $m_return[6] = $output;
        
        return $m_return;
    }
    
    
    
    /**************************************************************************/
    /*
    /* Form for answer of student
    /*
    /**************************************************************************/



   /**
        * Generates the HTML-Output of an exercise to represent
        * it to the student to get a solution.
        *
        * Former choices or entries will be shown.
        * Also used to allow lecturer assess the solution.
        *
        * @param int $p_exercise_id the unique id of the exercise
        * @param int $p_exercise_sheet_id the unique id of the exercise sheet
        * @param XML $p_exerciseXML the definition of the exercise in XML
        * @param String $p_exercise_name the name of the exercise
        * @param XML $p_solutionXML the former solution of the learner. Optional.
        * @param int $p_exercise_solution_id the id of the solution. Optional.
        *        (??? better to get/store in solution xml, ES)
        * @param String $p_student_comment the comment of the student to the current
        *         solution. Optional.
        * @param boolean $p_assess_solution TRUE means that the lecturer corrects the
        *        solution. Therefore, the lecturer cannot edit the solution itself.
        *        FALSE means that the student may edit the solution and submit it again.
        */

#        function printFormToGetAnswer($p_exercise_id    // old: genOutput
#                , $p_exercise_sheet_id
#                , $p_exerciseXML
#                , $p_exercise_name
#                , $p_solutionXML                        = ""
#                , $p_exercise_solution_id       = ""
#                , $p_student_comment            = ""
#                , $p_assess_solution            = FALSE) {

#                global $g_reset;
#                global $g_exercise_former_solution;
#                $m_number = getExternalParam("number");
#                $m_mode = getExternalParam("mode");
#                if(!$m_number){
#                        $m_number =1;
#                }else if($g_reset){
#                        $m_number =1;
#                }else{
#                        $m_number++;
#                }
                //echo $g_exercise_former_solution;
#        if($g_exercise_former_solution){
#                        $m_exercise_former_solution = $g_exercise_former_solution;
#                }else{
#                        $m_exercise_former_solution = stripslashes(getExternalParam("solution"));
#                }
#                $m_query = stripslashes(getExternalParam("query"));
#                $i              = 1;    // counter  (??? starts at 0 below, ES)
#                $msg    = "";   // return value
#                $m_exercise_former_solutionArray;

                /*************************************************************************/
                /* Checking wether data in form-fields is editable or not.
                /*************************************************************************/

#                if($p_assess_solution === TRUE) {
                        // $m_htmladd = " readonly ";
#                }

                /*************************************************************************/
                /* Get exercise specific values from XML
                /*************************************************************************/

#                $m_answerArray = $this->getTagsFromXML($p_exerciseXML, "Answer");

#                if(!$m_exercise_former_solution && $p_solutionXML != "")
#                {
#                        $tmpArray = $this->getTagsFromXML($p_solutionXML, "body");
#                        $m_exercise_former_solution = $tmpArray[0];
#                }

#                $m_hintArray = $this->getTagsFromXML($p_exerciseXML, "Hint");
#                $m_hint = $m_hintArray[0];

                /*************************************************************************/
                /* Formular: start
                /*************************************************************************/

                //!--<form enctype="multipart/form-data" action="'.vips_url().'" method="POST">-->

#                        $out .=  $this->getStudentHiddenAnswerFormularEntries(get_class($this)
#                        , $p_exercise_id
#                        , $p_exercise_sheet_id
#                        , $p_exercise_solution_id
#                        , $p_assess_solution);

#                $out .= '<table border="0" class="blank" cellpadding="2" cellspacing="0">';

#                        $out .=  $this->getStudentExerciseHeadrow($p_exercise_name
#                                , $this->g_ExerciseName
#                                , 0
#                                , $p_exerciseXML);
#                        if($m_mode =="Vorschau"){
#                                $out .=  $this->getStudentExerciseQuestion(5, $p_exerciseXML, TRUE);
#                        }
#                        else{
#                                $out .= $this->getStudentExerciseQuestion(5, $p_exerciseXML);
#                        }

                /*************************************************************************/
                /* Formular: answers, unique for this type of exercise
                /* TODO: Fix input type / handling for query button in save solution to query
                /* the query and not store the solution.
                /* Afterwards add the prolog backaend.
                /*************************************************************************/

#$out .= '<tr><td colspan=3><br>';

#                if($m_mode !="Vorschau"){
#                        $out .= '<nobr><input type=submit name=mode value="QUERY ">
#                <input type=submit name=mode value="QUERY NEXT">
#<input name=query value="'.$m_query.'" size=60></nobr>';
#                }
#                $out .= '<br>';

#                if ($m_exercise_former_solution) {
#                        if($m_mode == "PREVIEW"){
#                                $out .=  $this->getTextarea("solution"
#                                                , $m_htmladd
#                                                , $m_exercise_former_solution);
#                        }
#                        else{
#                                $out .=  $this->getTextarea("solution"
#                                                , $m_htmladd
#                                                , stripslashes($m_exercise_former_solution));
#                        }
#                }
#                else {
#                        $out .= $this->getTextarea("solution"
#                                , $m_htmladd
#                                , $m_hint);
#                }
#$out .= '
#</td></tr>';
                /*************************************************************************/
                /* Formular: student comment and submit button
                /* submit button only if solution is currently NOT assessed by lecturer,
                /* that means the sutdent has to solve the exercise
                /*************************************************************************/



#                if($m_mode != "Vorschau"){
#                        $out .= $this->getTablerowEmpty(5);
#                        $out .= $this->getStudentExerciseComment($m_htmladd, 15, $p_student_comment);
#                        $out .=  "<tr><td>
#      <input type= \"hidden\" name=\"MAX_FILE_SIZE\" value=\"3000000\">
#      ". _("Datei hochladen").": <input name=\"userfile\" type=\"file\">
#      <input type=\"submit\" name=\"mode\" value=\"UPLOAD\"></td></tr>";
#                }
#                if($p_assess_solution === FALSE) {
#                        $out .= $this->getTablerowEmpty(15);
#                         if($m_mode != "Vorschau"){
#                                $out .= "<td><input type=\"submit\" name=\"mode\" value=\"DOWNLOAD\"></td>";
#                                $out .= $this->getStudentSubmitButton(15);
#                        }
#                        $out .= '</table>
#                        <input type="hidden" name="number_of_answers" value="'.$i.'">
#                        <input type="hidden" name="number" value="'.$m_number.'">
#                        </form>';
#                }
#                else {
#                        $out .= '<input type="hidden" name="number_of_answers" value="'.$i.'">
#                        <input type="hidden" name="number" value="'.$m_number.'">';
#                }
#                return $out ;
#        } // end function
    
    
    
    /**************************************************************************/
    /*
    /* Form for generation or modification of an exercise
    /*
    /**************************************************************************/
    
    
    
    /**
     * Produces the html-output to get the data needed for the exercise from the
        * lecturer.
        *
        * @output HTML prints HTML-table with 3 (three) columns.
        * @auhor Erik Schmitt
        * @date 2003-02-23
        * @param int $p_exercise_sheet_id the number of the exercise sheet the exercise
        *            belongs to.
        * @param int $p_exercise_position the absolute position of the exercise
                                in the exercise sheet
        * @param int $p_exercise_maximum_score the maximum score
        * @param int $p_exercise_id th eid of the exercise. Empty if exercise is new.
        * @param XML $p_exerciseXML the content of the exercise to modify
        *            exisiting exercise. Empty if exercise is new.
        */

#        function printFormToGenerateExercise($p_exercise_sheet_id       // genExercise
#                , $p_exercise_position
#                , $p_exercise_maximum_score
#                , $p_exercise_id = ""
#                , $p_exerciseXML = "") {

                /*************************************************************************/
                /* Data: initialize
                /*************************************************************************/

#                $counter                        = 1; // array start at 0 normally , but anyway ...
#                $m_exercise_type        = get_class($this);     //the type is the name of the class

                /*************************************************************************/
                /* XML: extract data unique for this exercise type (and not accessed by
                /* the class Exercise (exercise.php).
                /*************************************************************************/

#                if($p_exerciseXML != "")
#                {
                        // ANSWER
#                        $dom_exerciseXML = $this->getDomXML($p_exerciseXML); // neede to check attribute
#                        $meine_elemente = $dom_exerciseXML->get_elements_by_tagname("Answer");
#                        foreach ($meine_elemente as $knoten)
#                        {
#                                $m_exercise_answerArray[$counter]  = utf8_decode($knoten->get_content());
#                                if($knoten->get_attribute("Correct") == "1") // TRUE
#                                {
#                                        $m_exercise_correctTrueArray[$counter]  = 'checked="checked"';
#                                        $m_exercise_correctFalseArray[$counter] = "";
#                                }
#                                else // FALSE
#                                {
#                                        $m_exercise_correctTrueArray[$counter]  = "";
#                                        $m_exercise_correctFalseArray[$counter] = 'checked="checked"';
#                                }
#                                $counter++;
#                        }
#                } // end if


                /*************************************************************************/
                /* Formular: construct
                /* Add hidden form fields.
                /*************************************************************************/

#                $out .=
#                '<h2>'.$this->g_ExerciseName .' - Aufgabe</h2>

#                <form enctype="multipart/form-data" action="'.vips_url().'" method="POST">';

#                $out .= $this->getLecturerHiddenFormularEntries($m_exercise_type
#                        , $p_exercise_id
#                        , $p_exercise_sheet_id
#                        , $p_exercise_position
#                        , $p_exercise_maximum_score);

#                $out .= '<table border="0" cellpadding="2" cellspacing="0">
#                 <tr><td colspan=3><br><nobr><input type=submit name=mode value="Vorschau">
#                <tr>';

#                $out .=  $this->getInputfieldName(5, $p_exerciseXML);
#                $out .= $this->getTextareaQuestion(15, $p_exerciseXML);

                /*************************************************************************/
                /* Construct: answer boxes unique for this exercise type
                /*************************************************************************/

#                $counter = 1;
#                while($counter <= $this->g_numberOfAnswers){
#                        $out .= '
#                        <tr>
#                                <td>
#                                        '. _("Musterlsung") /*. $counter*/ .'
#                                </td>
#                                <td width="10">
#                                        &nbsp;
#                                </td>
#                                <td>
#                                        '.$this->getTextarea("antwort-".$counter
#                                                , ""
#                                                , stripslashes($m_exercise_answerArray[$counter])).'
#                                        <label>
#                                </td>
#                        </tr>';
#                        $out .= $this->getTablerowEmpty(10);
#                        $counter++;
#                } // end while: answer boxes

                /*************************************************************************/
                /* Construct: Default fields for an exercise
                /*************************************************************************/

#                $out .= $this->getTablerowEmpty(15);
#                $out .= $this->getTextareaCorrectSolutionComment(15, $p_exerciseXML);
#                $out .= $this->getInputfieldPictureURL(15, $p_exerciseXML);
#                $out .= $this->getTextareaHint(15, $p_exerciseXML);
#                $out .= $this->getCheckboxesTesttypes(15, $p_exerciseXML);
#                $out .= $this->getSubmitButton(15);

#                $out .= '</table>
#                        </form>';
#                return $out;
#        }
    
    
    
    function download($file , $name) {
        $size = filesize($file);
        header("Content-type: application/octet-stream");
        header("Content-disposition: attachment; filename=".$name);
        header("Content-Length: ".$size);
        header("Pragma: no-cache");
        header("Expires: 0");
        readfile($file);
    }
    
    
    
    function downloadSolution($p_exercise_name) {
        $p_solution = stripslashes(getExternalParam('answer_0'));
        
        // this hack is necessary to disable the standard Stud.IP layout
        ob_end_clean();
        
        header('Content-Type: text/plain; charset=ISO-8859-1');
        header('Content-Disposition: attachment; filename="'.$p_exercise_name.'.txt"');
        header('Pragma: public');
        
        echo $p_solution;
        
        ob_start('discard_buffer');
    }
    
    
    
    function uploadSolution() {
        
        $g_solution = '';
        if ($_FILES['pl_userfile']) {
            if (is_uploaded_file($_FILES['pl_userfile']['tmp_name'])) {
                $g_solution = file_get_contents($_FILES['pl_userfile']['tmp_name']);
            }
        }
        else {
            echo "Upload failed!";
        }
        
        return $g_solution;
    }
    
    
    
    /****************************************************************************************/
    /* Queries the query inserted by the student with the corresponding code of the exercise.
    /* @param int exercise_id the id of the exercise that sould be queried.
    /* @param string exerciseXML the exercise code containing the info about the exercise
    /****************************************************************************************/
    
    function evaluateQuery($p_user_id, $p_course, $p_number = 1) {

        $username = get_solver_name($p_user_id);

        $answer = stripslashes($_POST["answer_0"]);
        $query  = stripslashes($_POST["pl_query"]);
        
        $out = "";
        $shell_output = "";
        $output_array = array();
        
        $fp = fsockopen("mvc.ikw.uni-osnabrueck.de", 2213); //, $errno, $errstr, 30);
        if (!$fp) {
            echo "ERROR fsockopen: PROLOG compiler couldn't be reached'."; //"$errstr ($errno)<br />\n";
        } else {
            $queryXML = "<prolog>\n<user>\n$username\n</user>\n<course>\n$p_course\n</course>\n<magic>\n!ViPS!\n</magic>\n<number>\n".$p_number."\n</number>\n<type>\nquery\n</type>\n<exercise>\n".$answer."\n</exercise>\n<testcase>\n".$query."\n</testcase>\n</prolog>\n";
            fputs($fp, $queryXML);
            while (!feof($fp)) {
                $output_array[] = fgets($fp);
            }
            //echo "<br>shell_output: $shell_output ";
            fclose($fp);
        }
        
        
        foreach ($output_array as $line) {
            if ($line != "\n") {
                $shell_output .= $line;
            }
        }
        
        $out .= "<br><pre>$shell_output</pre>";
        
        return $out;
    }
    
    
    
    /**************************************************************************/
    /*
    /* XML-generating routines
    /*
    /**************************************************************************/
    
    
    
    /**
     * Generates generates an XML-String containing the solution of the
     * student.
     *
     * Gets ist values to be stored in the XML-String from the
     * Get/Post environment.
     *
     * @param int $exercise_id the id of the exercise the solution related to.
     * @param int $p_number_of_answers the number of answers possible (??? not a class variable, ES)
     * @return XML the XML-String containing the solutions of the student.
     *
     * @todo names of the exml entities are not well choosen. A change will have
     * impact on other parts of the code, of course.
     */
    
    function genSolution($p_exercise_id, $p_number_of_answers) {
        
        $i    = 0;
        $msg  = "<solution id=\"".$p_exercise_id."\">";
        $msg .= "<answer id=\"0\">";
        $msg .= "<body>".htmlspecialchars(getExternalParam("answer_0"))."</body>";
        $msg .= "</answer>";
        
        $msg .= "</solution>";
        return ($msg);
    }
    
    
    
    /**
     * Generate the description af an exercise in an XML-String.
     *
     * Gets ist values to be stored in the XML-String from the
     * Get/Post environment.
     *
     * @return XML the SML-String describing the exercise in terms of its
     * name, questions, worng and correct solutions etc.
     */
    
    function getExerciseConstruct() {
        
        /*************************************************************************/
        /* Get data
        /*************************************************************************/
        
        $m_exercise_language = "de";
        $m_exercise_type     = getExternalParam("exercise_type");
        $m_exercise_question = getExternalParam("exercise_question");
        
        $m_exercise_name     = getExternalParam("exercise_name");
//              echo "<br><b>Testausgabe! Bitte ignorieren!</b> pl_exercise, getExerciseConstruct GEP(exercise_name):".$m_exercise_name;
        $m_exercise_hint     = getExternalParam("exercise_hint");
        
        $m_exercise_comment  = getExternalParam("exercise_comment");
        
        $m_exercise_pic_url  = getExternalParam("exercise_pic_url");
        $m_provides          = getExternalParam("provides");
        $m_depends           = getExternalParam("depends");
        $m_optional_depends  = getExternalParam("optional_depends");
        //Musterloesung
        $m_exercise_answer   = getExternalParam("answer_0");
        //Vorgegebene Antwort
        $m_answer_default    = getExternalParam("answer_default");
        //Vorgegebene Anfrage
        $m_query_default     = getExternalParam("query_default");
        
        $counter             = 1;
        
        /*do {
                        // -lsg determines correctness: 1 means yes, 0 means no
                        $m_exercise_answerArray[$counter]  = getExternalParam("antwort-".$counter);
                        $counter++;
                } while ($counter <= $this->g_numberOfAnswers);
                */
        
        /*************************************************************************/
        /* Construct XML
        /*************************************************************************/
        
        $xmlop  = "<TestItem ID=\"" . $m_exercise_type . "\" Type=\"MultipleChoice\" Language=\"" . $m_exercise_language . "\">";
        $xmlop .= "<Name>".htmlspecialchars($m_exercise_name)."</Name>";
        // In this special case the hint is displayed inside a textbox to provide comments
        // and code fragments to the student.
        $xmlop .= "<Hint>".htmlspecialchars($m_exercise_hint)."</Hint>";
        $xmlop .= "<CommentField Visible=\"".$m_exercise_comment."\"></CommentField>";
        $xmlop .= "<PictureURL>".htmlspecialchars($m_exercise_pic_url)."</PictureURL>";
        $xmlop .= "<Provides>".htmlspecialchars($m_provides)."</Provides>";
        $xmlop .= "<Depends>".htmlspecialchars($m_depends)."</Depends>";
        $xmlop .= "<OptionalDepends>".htmlspecialchars($m_optional_depends)."</OptionalDepends>";
        $xmlop .= "<Question>";
        $xmlop .= "<Paragraph>".htmlspecialchars($m_exercise_question)."</Paragraph>";
        $xmlop .= "</Question>";
        $xmlop .= "<Answer>".htmlspecialchars($m_exercise_answer)."</Answer>";
        $xmlop .= "<AnswerDefault>".htmlspecialchars($m_answer_default)."</AnswerDefault>";
        $xmlop .= "<QueryDefault>".htmlspecialchars($m_query_default)."</QueryDefault>";
        
        $xmlop .= "</TestItem>";
        //echo "XML<pre>".html_entity_decode($xmlop)."</pre>";
        
        /*************************************************************************/
        /* Return XML
        /*************************************************************************/
        
        return ($xmlop);
    }

    /**
     * Export this exercise to plain text format.
     */
    function exportText ($exercise_xml)
    {
        $result = parent::exportText($exercise_xml, 'PL-Frage');

        $dom_xml = $this->getDomXML($exercise_xml);
        $answers = $dom_xml->get_elements_by_tagname('Answer');

        $answer_text    = utf8_decode($answers[0]->get_content());
        $answer_default = $this->getTagsFromXML($exercise_xml, 'AnswerDefault');
        $answer_default = $answer_default[0];
        // $query_default  = $this->getTagsFromXML($exercise_xml, 'QueryDefault');
        // $query_default  = $query_default[0];

        if ($answer_default != '')
        {
            $result .= "Vorgabe:\n";
            $result .= $answer_default."\n";
            $result .= "\\Vorgabe\n";
        }

        if ($answer_text != '')
        {
            $result .= "Antwort:\n";
            $result .= $answer_text."\n";
            $result .= "\\Antwort\n";
        }

        return $result;
    }
}
?>
